<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AcceptablePaymentCard StructType
 * Meta information extracted from the WSDL
 * - documentation: Provides the information needed to describe a type of payment card that is acceptable as a form of payment. A usage fee (amount or percentage) may also be stated for this particular card type. | Specific information of one payment
 * card that is acceptable as a form of payment.
 * @subpackage Structs
 */
class AcceptablePaymentCard extends AbstractStructBase
{
    /**
     * The TPA_Extensions
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - ref: TPA_Extensions
     * @var mixed
     */
    public $TPA_Extensions;
    /**
     * Constructor method for AcceptablePaymentCard
     * @uses AcceptablePaymentCard::setTPA_Extensions()
     * @param mixed $tPA_Extensions
     */
    public function __construct($tPA_Extensions = null)
    {
        $this
            ->setTPA_Extensions($tPA_Extensions);
    }
    /**
     * Get TPA_Extensions value
     * @return mixed|null
     */
    public function getTPA_Extensions()
    {
        return $this->TPA_Extensions;
    }
    /**
     * Set TPA_Extensions value
     * @param mixed $tPA_Extensions
     * @return \StructType\AcceptablePaymentCard
     */
    public function setTPA_Extensions($tPA_Extensions = null)
    {
        $this->TPA_Extensions = $tPA_Extensions;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AcceptablePaymentCard
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
