<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BookingRules StructType
 * Meta information extracted from the WSDL
 * - documentation: A collection of booking rules. Booking rules can be sent separately in the HotelBookingRuleNotif message or as part of the RatePlanNotif.
 * @subpackage Structs
 */
class BookingRules extends BookingRulesType
{
    /**
     * The InventoryInfo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\InventoryInfo
     */
    public $InventoryInfo;
    /**
     * Constructor method for BookingRules
     * @uses BookingRules::setInventoryInfo()
     * @param \StructType\InventoryInfo $inventoryInfo
     */
    public function __construct(\StructType\InventoryInfo $inventoryInfo = null)
    {
        $this
            ->setInventoryInfo($inventoryInfo);
    }
    /**
     * Get InventoryInfo value
     * @return \StructType\InventoryInfo|null
     */
    public function getInventoryInfo()
    {
        return $this->InventoryInfo;
    }
    /**
     * Set InventoryInfo value
     * @param \StructType\InventoryInfo $inventoryInfo
     * @return \StructType\BookingRules
     */
    public function setInventoryInfo(\StructType\InventoryInfo $inventoryInfo = null)
    {
        $this->InventoryInfo = $inventoryInfo;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\BookingRules
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
