<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ContactsType StructType
 * Meta information extracted from the WSDL
 * - documentation: Provides detailed name information.
 * @subpackage Structs
 */
class ContactsType extends AbstractStructBase
{
    /**
     * The Name
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\Name[]
     */
    public $Name;
    /**
     * Constructor method for ContactsType
     * @uses ContactsType::setName()
     * @param \StructType\Name[] $name
     */
    public function __construct(array $name = array())
    {
        $this
            ->setName($name);
    }
    /**
     * Get Name value
     * @return \StructType\Name[]|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * This method is responsible for validating the values passed to the setName method
     * This method is willingly generated in order to preserve the one-line inline validation within the setName method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateNameForArrayConstraintsFromSetName(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $contactsTypeNameItem) {
            // validation for constraint: itemType
            if (!$contactsTypeNameItem instanceof \StructType\Name) {
                $invalidValues[] = is_object($contactsTypeNameItem) ? get_class($contactsTypeNameItem) : sprintf('%s(%s)', gettype($contactsTypeNameItem), var_export($contactsTypeNameItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Name property can only contain items of type \StructType\Name, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Name value
     * @throws \InvalidArgumentException
     * @param \StructType\Name[] $name
     * @return \StructType\ContactsType
     */
    public function setName(array $name = array())
    {
        // validation for constraint: array
        if ('' !== ($nameArrayErrorMessage = self::validateNameForArrayConstraintsFromSetName($name))) {
            throw new \InvalidArgumentException($nameArrayErrorMessage, __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Add item to Name value
     * @throws \InvalidArgumentException
     * @param \StructType\Name $item
     * @return \StructType\ContactsType
     */
    public function addToName(\StructType\Name $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Name) {
            throw new \InvalidArgumentException(sprintf('The Name property can only contain items of type \StructType\Name, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Name[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ContactsType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
