<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EnvironmentalImpactType StructType
 * Meta information extracted from the WSDL
 * - documentation: Property environmental impact and green program and initiative information.
 * @subpackage Structs
 */
class EnvironmentalImpactType extends AbstractStructBase
{
    /**
     * The CarbonFootprint
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CarbonFootprint
     */
    public $CarbonFootprint;
    /**
     * The Water
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Water
     */
    public $Water;
    /**
     * The Energy
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Energy
     */
    public $Energy;
    /**
     * The Recycling
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Recycling
     */
    public $Recycling;
    /**
     * The General
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\General
     */
    public $General;
    /**
     * Constructor method for EnvironmentalImpactType
     * @uses EnvironmentalImpactType::setCarbonFootprint()
     * @uses EnvironmentalImpactType::setWater()
     * @uses EnvironmentalImpactType::setEnergy()
     * @uses EnvironmentalImpactType::setRecycling()
     * @uses EnvironmentalImpactType::setGeneral()
     * @param \StructType\CarbonFootprint $carbonFootprint
     * @param \StructType\Water $water
     * @param \StructType\Energy $energy
     * @param \StructType\Recycling $recycling
     * @param \StructType\General $general
     */
    public function __construct(\StructType\CarbonFootprint $carbonFootprint = null, \StructType\Water $water = null, \StructType\Energy $energy = null, \StructType\Recycling $recycling = null, \StructType\General $general = null)
    {
        $this
            ->setCarbonFootprint($carbonFootprint)
            ->setWater($water)
            ->setEnergy($energy)
            ->setRecycling($recycling)
            ->setGeneral($general);
    }
    /**
     * Get CarbonFootprint value
     * @return \StructType\CarbonFootprint|null
     */
    public function getCarbonFootprint()
    {
        return $this->CarbonFootprint;
    }
    /**
     * Set CarbonFootprint value
     * @param \StructType\CarbonFootprint $carbonFootprint
     * @return \StructType\EnvironmentalImpactType
     */
    public function setCarbonFootprint(\StructType\CarbonFootprint $carbonFootprint = null)
    {
        $this->CarbonFootprint = $carbonFootprint;
        return $this;
    }
    /**
     * Get Water value
     * @return \StructType\Water|null
     */
    public function getWater()
    {
        return $this->Water;
    }
    /**
     * Set Water value
     * @param \StructType\Water $water
     * @return \StructType\EnvironmentalImpactType
     */
    public function setWater(\StructType\Water $water = null)
    {
        $this->Water = $water;
        return $this;
    }
    /**
     * Get Energy value
     * @return \StructType\Energy|null
     */
    public function getEnergy()
    {
        return $this->Energy;
    }
    /**
     * Set Energy value
     * @param \StructType\Energy $energy
     * @return \StructType\EnvironmentalImpactType
     */
    public function setEnergy(\StructType\Energy $energy = null)
    {
        $this->Energy = $energy;
        return $this;
    }
    /**
     * Get Recycling value
     * @return \StructType\Recycling|null
     */
    public function getRecycling()
    {
        return $this->Recycling;
    }
    /**
     * Set Recycling value
     * @param \StructType\Recycling $recycling
     * @return \StructType\EnvironmentalImpactType
     */
    public function setRecycling(\StructType\Recycling $recycling = null)
    {
        $this->Recycling = $recycling;
        return $this;
    }
    /**
     * Get General value
     * @return \StructType\General|null
     */
    public function getGeneral()
    {
        return $this->General;
    }
    /**
     * Set General value
     * @param \StructType\General $general
     * @return \StructType\EnvironmentalImpactType
     */
    public function setGeneral(\StructType\General $general = null)
    {
        $this->General = $general;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\EnvironmentalImpactType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
