<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ExchResidualFareComponent StructType
 * Meta information extracted from the WSDL
 * - documentation: The exchanged residual fare component information.
 * @subpackage Structs
 */
class ExchResidualFareComponent extends FareComponentType
{
    /**
     * The Taxes
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Taxes
     */
    public $Taxes;
    /**
     * The TotalAmount
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\TotalAmount
     */
    public $TotalAmount;
    /**
     * Constructor method for ExchResidualFareComponent
     * @uses ExchResidualFareComponent::setTaxes()
     * @uses ExchResidualFareComponent::setTotalAmount()
     * @param \StructType\Taxes $taxes
     * @param \StructType\TotalAmount $totalAmount
     */
    public function __construct(\StructType\Taxes $taxes = null, \StructType\TotalAmount $totalAmount = null)
    {
        $this
            ->setTaxes($taxes)
            ->setTotalAmount($totalAmount);
    }
    /**
     * Get Taxes value
     * @return \StructType\Taxes|null
     */
    public function getTaxes()
    {
        return $this->Taxes;
    }
    /**
     * Set Taxes value
     * @param \StructType\Taxes $taxes
     * @return \StructType\ExchResidualFareComponent
     */
    public function setTaxes(\StructType\Taxes $taxes = null)
    {
        $this->Taxes = $taxes;
        return $this;
    }
    /**
     * Get TotalAmount value
     * @return \StructType\TotalAmount|null
     */
    public function getTotalAmount()
    {
        return $this->TotalAmount;
    }
    /**
     * Set TotalAmount value
     * @param \StructType\TotalAmount $totalAmount
     * @return \StructType\ExchResidualFareComponent
     */
    public function setTotalAmount(\StructType\TotalAmount $totalAmount = null)
    {
        $this->TotalAmount = $totalAmount;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ExchResidualFareComponent
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
