<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FlightLeg StructType
 * Meta information extracted from the WSDL
 * - documentation: Used to specify the free baggage allowance for this flight leg. | The flight leg information for the fare component.
 * @subpackage Structs
 */
class FlightLeg extends BookFlightSegmentType
{
    /**
     * The SurchargeInd
     * Meta information extracted from the WSDL
     * - documentation: When true, a surcharge applies to this flight leg.
     * - use: optional
     * @var bool
     */
    public $SurchargeInd;
    /**
     * Constructor method for FlightLeg
     * @uses FlightLeg::setSurchargeInd()
     * @param bool $surchargeInd
     */
    public function __construct($surchargeInd = null)
    {
        $this
            ->setSurchargeInd($surchargeInd);
    }
    /**
     * Get SurchargeInd value
     * @return bool|null
     */
    public function getSurchargeInd()
    {
        return $this->SurchargeInd;
    }
    /**
     * Set SurchargeInd value
     * @param bool $surchargeInd
     * @return \StructType\FlightLeg
     */
    public function setSurchargeInd($surchargeInd = null)
    {
        // validation for constraint: boolean
        if (!is_null($surchargeInd) && !is_bool($surchargeInd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($surchargeInd, true), gettype($surchargeInd)), __LINE__);
        }
        $this->SurchargeInd = $surchargeInd;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\FlightLeg
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
