<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GDS_Statuses StructType
 * Meta information extracted from the WSDL
 * - documentation: Collection of GDS Statuses.
 * @subpackage Structs
 */
class GDS_Statuses extends AbstractStructBase
{
    /**
     * The GDS_Status
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\GDS_Status[]
     */
    public $GDS_Status;
    /**
     * Constructor method for GDS_Statuses
     * @uses GDS_Statuses::setGDS_Status()
     * @param \StructType\GDS_Status[] $gDS_Status
     */
    public function __construct(array $gDS_Status = array())
    {
        $this
            ->setGDS_Status($gDS_Status);
    }
    /**
     * Get GDS_Status value
     * @return \StructType\GDS_Status[]|null
     */
    public function getGDS_Status()
    {
        return $this->GDS_Status;
    }
    /**
     * This method is responsible for validating the values passed to the setGDS_Status method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGDS_Status method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGDS_StatusForArrayConstraintsFromSetGDS_Status(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $gDS_StatusesGDS_StatusItem) {
            // validation for constraint: itemType
            if (!$gDS_StatusesGDS_StatusItem instanceof \StructType\GDS_Status) {
                $invalidValues[] = is_object($gDS_StatusesGDS_StatusItem) ? get_class($gDS_StatusesGDS_StatusItem) : sprintf('%s(%s)', gettype($gDS_StatusesGDS_StatusItem), var_export($gDS_StatusesGDS_StatusItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The GDS_Status property can only contain items of type \StructType\GDS_Status, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set GDS_Status value
     * @throws \InvalidArgumentException
     * @param \StructType\GDS_Status[] $gDS_Status
     * @return \StructType\GDS_Statuses
     */
    public function setGDS_Status(array $gDS_Status = array())
    {
        // validation for constraint: array
        if ('' !== ($gDS_StatusArrayErrorMessage = self::validateGDS_StatusForArrayConstraintsFromSetGDS_Status($gDS_Status))) {
            throw new \InvalidArgumentException($gDS_StatusArrayErrorMessage, __LINE__);
        }
        $this->GDS_Status = $gDS_Status;
        return $this;
    }
    /**
     * Add item to GDS_Status value
     * @throws \InvalidArgumentException
     * @param \StructType\GDS_Status $item
     * @return \StructType\GDS_Statuses
     */
    public function addToGDS_Status(\StructType\GDS_Status $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GDS_Status) {
            throw new \InvalidArgumentException(sprintf('The GDS_Status property can only contain items of type \StructType\GDS_Status, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->GDS_Status[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GDS_Statuses
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
