<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Guarantee StructType
 * Meta information extracted from the WSDL
 * - documentation: Guarantee information that applies to the rate plan. A maximum of 5 occurances are available for use depending on the context.
 * @subpackage Structs
 */
class Guarantee extends GuaranteeType
{
    /**
     * The AmountPercent
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\AmountPercent
     */
    public $AmountPercent;
    /**
     * Constructor method for Guarantee
     * @uses Guarantee::setAmountPercent()
     * @param \StructType\AmountPercent $amountPercent
     */
    public function __construct(\StructType\AmountPercent $amountPercent = null)
    {
        $this
            ->setAmountPercent($amountPercent);
    }
    /**
     * Get AmountPercent value
     * @return \StructType\AmountPercent|null
     */
    public function getAmountPercent()
    {
        return $this->AmountPercent;
    }
    /**
     * Set AmountPercent value
     * @param \StructType\AmountPercent $amountPercent
     * @return \StructType\Guarantee
     */
    public function setAmountPercent(\StructType\AmountPercent $amountPercent = null)
    {
        $this->AmountPercent = $amountPercent;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Guarantee
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
