<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for IndCoverageReqsType StructType
 * Meta information extracted from the WSDL
 * - documentation: Contains certain traveler-specific information required for quoting or booking an insurance plan.
 * @subpackage Structs
 */
class IndCoverageReqsType extends AbstractStructBase
{
    /**
     * The IndTripCost
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\IndTripCost
     */
    public $IndTripCost;
    /**
     * The FlightAccidentAmount
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\FlightAccidentAmount
     */
    public $FlightAccidentAmount;
    /**
     * The CoveredLuggage
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CoveredLuggage
     */
    public $CoveredLuggage;
    /**
     * The PreexistingConditions
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\PreexistingConditions
     */
    public $PreexistingConditions;
    /**
     * Constructor method for IndCoverageReqsType
     * @uses IndCoverageReqsType::setIndTripCost()
     * @uses IndCoverageReqsType::setFlightAccidentAmount()
     * @uses IndCoverageReqsType::setCoveredLuggage()
     * @uses IndCoverageReqsType::setPreexistingConditions()
     * @param \StructType\IndTripCost $indTripCost
     * @param \StructType\FlightAccidentAmount $flightAccidentAmount
     * @param \StructType\CoveredLuggage $coveredLuggage
     * @param \StructType\PreexistingConditions $preexistingConditions
     */
    public function __construct(\StructType\IndTripCost $indTripCost = null, \StructType\FlightAccidentAmount $flightAccidentAmount = null, \StructType\CoveredLuggage $coveredLuggage = null, \StructType\PreexistingConditions $preexistingConditions = null)
    {
        $this
            ->setIndTripCost($indTripCost)
            ->setFlightAccidentAmount($flightAccidentAmount)
            ->setCoveredLuggage($coveredLuggage)
            ->setPreexistingConditions($preexistingConditions);
    }
    /**
     * Get IndTripCost value
     * @return \StructType\IndTripCost|null
     */
    public function getIndTripCost()
    {
        return $this->IndTripCost;
    }
    /**
     * Set IndTripCost value
     * @param \StructType\IndTripCost $indTripCost
     * @return \StructType\IndCoverageReqsType
     */
    public function setIndTripCost(\StructType\IndTripCost $indTripCost = null)
    {
        $this->IndTripCost = $indTripCost;
        return $this;
    }
    /**
     * Get FlightAccidentAmount value
     * @return \StructType\FlightAccidentAmount|null
     */
    public function getFlightAccidentAmount()
    {
        return $this->FlightAccidentAmount;
    }
    /**
     * Set FlightAccidentAmount value
     * @param \StructType\FlightAccidentAmount $flightAccidentAmount
     * @return \StructType\IndCoverageReqsType
     */
    public function setFlightAccidentAmount(\StructType\FlightAccidentAmount $flightAccidentAmount = null)
    {
        $this->FlightAccidentAmount = $flightAccidentAmount;
        return $this;
    }
    /**
     * Get CoveredLuggage value
     * @return \StructType\CoveredLuggage|null
     */
    public function getCoveredLuggage()
    {
        return $this->CoveredLuggage;
    }
    /**
     * Set CoveredLuggage value
     * @param \StructType\CoveredLuggage $coveredLuggage
     * @return \StructType\IndCoverageReqsType
     */
    public function setCoveredLuggage(\StructType\CoveredLuggage $coveredLuggage = null)
    {
        $this->CoveredLuggage = $coveredLuggage;
        return $this;
    }
    /**
     * Get PreexistingConditions value
     * @return \StructType\PreexistingConditions|null
     */
    public function getPreexistingConditions()
    {
        return $this->PreexistingConditions;
    }
    /**
     * Set PreexistingConditions value
     * @param \StructType\PreexistingConditions $preexistingConditions
     * @return \StructType\IndCoverageReqsType
     */
    public function setPreexistingConditions(\StructType\PreexistingConditions $preexistingConditions = null)
    {
        $this->PreexistingConditions = $preexistingConditions;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\IndCoverageReqsType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
