<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InvBlockType StructType
 * Meta information extracted from the WSDL
 * - documentation: Used to define the details of an inventory block.
 * @subpackage Structs
 */
class InvBlockType extends AbstractStructBase
{
    /**
     * The HotelRef
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\HotelRef
     */
    public $HotelRef;
    /**
     * The InvBlockDates
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\InvBlockDates
     */
    public $InvBlockDates;
    /**
     * The RoomTypes
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\RoomTypes
     */
    public $RoomTypes;
    /**
     * The MethodInfo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\MethodInfo
     */
    public $MethodInfo;
    /**
     * The BlockDescriptions
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\BlockDescriptions
     */
    public $BlockDescriptions;
    /**
     * The Contacts
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Contacts
     */
    public $Contacts;
    /**
     * The DestinationSystemCodes
     * Meta information extracted from the WSDL
     * - documentation: A collection of destination system codes. These are systems for which this inventory block is targeted.
     * - minOccurs: 0
     * @var mixed
     */
    public $DestinationSystemCodes;
    /**
     * The TaxInformation
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\TaxInformation
     */
    public $TaxInformation;
    /**
     * Constructor method for InvBlockType
     * @uses InvBlockType::setHotelRef()
     * @uses InvBlockType::setInvBlockDates()
     * @uses InvBlockType::setRoomTypes()
     * @uses InvBlockType::setMethodInfo()
     * @uses InvBlockType::setBlockDescriptions()
     * @uses InvBlockType::setContacts()
     * @uses InvBlockType::setDestinationSystemCodes()
     * @uses InvBlockType::setTaxInformation()
     * @param \StructType\HotelRef $hotelRef
     * @param \StructType\InvBlockDates $invBlockDates
     * @param \StructType\RoomTypes $roomTypes
     * @param \StructType\MethodInfo $methodInfo
     * @param \StructType\BlockDescriptions $blockDescriptions
     * @param \StructType\Contacts $contacts
     * @param mixed $destinationSystemCodes
     * @param \StructType\TaxInformation $taxInformation
     */
    public function __construct(\StructType\HotelRef $hotelRef = null, \StructType\InvBlockDates $invBlockDates = null, \StructType\RoomTypes $roomTypes = null, \StructType\MethodInfo $methodInfo = null, \StructType\BlockDescriptions $blockDescriptions = null, \StructType\Contacts $contacts = null, $destinationSystemCodes = null, \StructType\TaxInformation $taxInformation = null)
    {
        $this
            ->setHotelRef($hotelRef)
            ->setInvBlockDates($invBlockDates)
            ->setRoomTypes($roomTypes)
            ->setMethodInfo($methodInfo)
            ->setBlockDescriptions($blockDescriptions)
            ->setContacts($contacts)
            ->setDestinationSystemCodes($destinationSystemCodes)
            ->setTaxInformation($taxInformation);
    }
    /**
     * Get HotelRef value
     * @return \StructType\HotelRef|null
     */
    public function getHotelRef()
    {
        return $this->HotelRef;
    }
    /**
     * Set HotelRef value
     * @param \StructType\HotelRef $hotelRef
     * @return \StructType\InvBlockType
     */
    public function setHotelRef(\StructType\HotelRef $hotelRef = null)
    {
        $this->HotelRef = $hotelRef;
        return $this;
    }
    /**
     * Get InvBlockDates value
     * @return \StructType\InvBlockDates|null
     */
    public function getInvBlockDates()
    {
        return $this->InvBlockDates;
    }
    /**
     * Set InvBlockDates value
     * @param \StructType\InvBlockDates $invBlockDates
     * @return \StructType\InvBlockType
     */
    public function setInvBlockDates(\StructType\InvBlockDates $invBlockDates = null)
    {
        $this->InvBlockDates = $invBlockDates;
        return $this;
    }
    /**
     * Get RoomTypes value
     * @return \StructType\RoomTypes|null
     */
    public function getRoomTypes()
    {
        return $this->RoomTypes;
    }
    /**
     * Set RoomTypes value
     * @param \StructType\RoomTypes $roomTypes
     * @return \StructType\InvBlockType
     */
    public function setRoomTypes(\StructType\RoomTypes $roomTypes = null)
    {
        $this->RoomTypes = $roomTypes;
        return $this;
    }
    /**
     * Get MethodInfo value
     * @return \StructType\MethodInfo|null
     */
    public function getMethodInfo()
    {
        return $this->MethodInfo;
    }
    /**
     * Set MethodInfo value
     * @param \StructType\MethodInfo $methodInfo
     * @return \StructType\InvBlockType
     */
    public function setMethodInfo(\StructType\MethodInfo $methodInfo = null)
    {
        $this->MethodInfo = $methodInfo;
        return $this;
    }
    /**
     * Get BlockDescriptions value
     * @return \StructType\BlockDescriptions|null
     */
    public function getBlockDescriptions()
    {
        return $this->BlockDescriptions;
    }
    /**
     * Set BlockDescriptions value
     * @param \StructType\BlockDescriptions $blockDescriptions
     * @return \StructType\InvBlockType
     */
    public function setBlockDescriptions(\StructType\BlockDescriptions $blockDescriptions = null)
    {
        $this->BlockDescriptions = $blockDescriptions;
        return $this;
    }
    /**
     * Get Contacts value
     * @return \StructType\Contacts|null
     */
    public function getContacts()
    {
        return $this->Contacts;
    }
    /**
     * Set Contacts value
     * @param \StructType\Contacts $contacts
     * @return \StructType\InvBlockType
     */
    public function setContacts(\StructType\Contacts $contacts = null)
    {
        $this->Contacts = $contacts;
        return $this;
    }
    /**
     * Get DestinationSystemCodes value
     * @return mixed|null
     */
    public function getDestinationSystemCodes()
    {
        return $this->DestinationSystemCodes;
    }
    /**
     * Set DestinationSystemCodes value
     * @param mixed $destinationSystemCodes
     * @return \StructType\InvBlockType
     */
    public function setDestinationSystemCodes($destinationSystemCodes = null)
    {
        $this->DestinationSystemCodes = $destinationSystemCodes;
        return $this;
    }
    /**
     * Get TaxInformation value
     * @return \StructType\TaxInformation|null
     */
    public function getTaxInformation()
    {
        return $this->TaxInformation;
    }
    /**
     * Set TaxInformation value
     * @param \StructType\TaxInformation $taxInformation
     * @return \StructType\InvBlockType
     */
    public function setTaxInformation(\StructType\TaxInformation $taxInformation = null)
    {
        $this->TaxInformation = $taxInformation;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\InvBlockType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
