<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for List_QuestionCategory StructType
 * Meta information extracted from the WSDL
 * - documentation: Review question categories
 * @subpackage Structs
 */
class List_QuestionCategory extends AbstractStructBase
{
    /**
     * The List
     * Meta information extracted from the WSDL
     * - documentation: An enumerated list.
     * @var mixed
     */
    public $List;
    /**
     * The Extension
     * Meta information extracted from the WSDL
     * - documentation: Code List extension information.
     * - minOccurs: 0
     * @var mixed
     */
    public $Extension;
    /**
     * Constructor method for List_QuestionCategory
     * @uses List_QuestionCategory::setList()
     * @uses List_QuestionCategory::setExtension()
     * @param mixed $list
     * @param mixed $extension
     */
    public function __construct($list = null, $extension = null)
    {
        $this
            ->setList($list)
            ->setExtension($extension);
    }
    /**
     * Get List value
     * @return mixed|null
     */
    public function getList()
    {
        return $this->List;
    }
    /**
     * Set List value
     * @param mixed $list
     * @return \StructType\List_QuestionCategory
     */
    public function setList($list = null)
    {
        $this->List = $list;
        return $this;
    }
    /**
     * Get Extension value
     * @return mixed|null
     */
    public function getExtension()
    {
        return $this->Extension;
    }
    /**
     * Set Extension value
     * @param mixed $extension
     * @return \StructType\List_QuestionCategory
     */
    public function setExtension($extension = null)
    {
        $this->Extension = $extension;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\List_QuestionCategory
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
