<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for LoyalPrograms StructType
 * Meta information extracted from the WSDL
 * - documentation: Collection of LoyalPrograms.
 * @subpackage Structs
 */
class LoyalPrograms extends AbstractStructBase
{
    /**
     * The LoyalProgram
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\LoyalProgram[]
     */
    public $LoyalProgram;
    /**
     * Constructor method for LoyalPrograms
     * @uses LoyalPrograms::setLoyalProgram()
     * @param \StructType\LoyalProgram[] $loyalProgram
     */
    public function __construct(array $loyalProgram = array())
    {
        $this
            ->setLoyalProgram($loyalProgram);
    }
    /**
     * Get LoyalProgram value
     * @return \StructType\LoyalProgram[]|null
     */
    public function getLoyalProgram()
    {
        return $this->LoyalProgram;
    }
    /**
     * This method is responsible for validating the values passed to the setLoyalProgram method
     * This method is willingly generated in order to preserve the one-line inline validation within the setLoyalProgram method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateLoyalProgramForArrayConstraintsFromSetLoyalProgram(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $loyalProgramsLoyalProgramItem) {
            // validation for constraint: itemType
            if (!$loyalProgramsLoyalProgramItem instanceof \StructType\LoyalProgram) {
                $invalidValues[] = is_object($loyalProgramsLoyalProgramItem) ? get_class($loyalProgramsLoyalProgramItem) : sprintf('%s(%s)', gettype($loyalProgramsLoyalProgramItem), var_export($loyalProgramsLoyalProgramItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The LoyalProgram property can only contain items of type \StructType\LoyalProgram, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set LoyalProgram value
     * @throws \InvalidArgumentException
     * @param \StructType\LoyalProgram[] $loyalProgram
     * @return \StructType\LoyalPrograms
     */
    public function setLoyalProgram(array $loyalProgram = array())
    {
        // validation for constraint: array
        if ('' !== ($loyalProgramArrayErrorMessage = self::validateLoyalProgramForArrayConstraintsFromSetLoyalProgram($loyalProgram))) {
            throw new \InvalidArgumentException($loyalProgramArrayErrorMessage, __LINE__);
        }
        $this->LoyalProgram = $loyalProgram;
        return $this;
    }
    /**
     * Add item to LoyalProgram value
     * @throws \InvalidArgumentException
     * @param \StructType\LoyalProgram $item
     * @return \StructType\LoyalPrograms
     */
    public function addToLoyalProgram(\StructType\LoyalProgram $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\LoyalProgram) {
            throw new \InvalidArgumentException(sprintf('The LoyalProgram property can only contain items of type \StructType\LoyalProgram, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->LoyalProgram[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\LoyalPrograms
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
