<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MethodInfo StructType
 * Meta information extracted from the WSDL
 * - documentation: This is used to indicate the reservation and billing methods for a single inventory block. | This is used to indicate the reservation and billing methods for the rate plan.
 * @subpackage Structs
 */
class MethodInfo extends AbstractStructBase
{
    /**
     * The BillingInstruction
     * Meta information extracted from the WSDL
     * - documentation: Billing instruction information.
     * - minOccurs: 0
     * @var mixed
     */
    public $BillingInstruction;
    /**
     * Constructor method for MethodInfo
     * @uses MethodInfo::setBillingInstruction()
     * @param mixed $billingInstruction
     */
    public function __construct($billingInstruction = null)
    {
        $this
            ->setBillingInstruction($billingInstruction);
    }
    /**
     * Get BillingInstruction value
     * @return mixed|null
     */
    public function getBillingInstruction()
    {
        return $this->BillingInstruction;
    }
    /**
     * Set BillingInstruction value
     * @param mixed $billingInstruction
     * @return \StructType\MethodInfo
     */
    public function setBillingInstruction($billingInstruction = null)
    {
        $this->BillingInstruction = $billingInstruction;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\MethodInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
