<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OTA_NotifReportRQ StructType
 * Meta information extracted from the WSDL
 * - documentation: This message is used to indicate the status of processing one or several previous messages.
 * @subpackage Structs
 */
class OTA_NotifReportRQ extends MessageAcknowledgementType
{
    /**
     * The NotifDetails
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\NotifDetails
     */
    public $NotifDetails;
    /**
     * Constructor method for OTA_NotifReportRQ
     * @uses OTA_NotifReportRQ::setNotifDetails()
     * @param \StructType\NotifDetails $notifDetails
     */
    public function __construct(\StructType\NotifDetails $notifDetails = null)
    {
        $this
            ->setNotifDetails($notifDetails);
    }
    /**
     * Get NotifDetails value
     * @return \StructType\NotifDetails|null
     */
    public function getNotifDetails()
    {
        return $this->NotifDetails;
    }
    /**
     * Set NotifDetails value
     * @param \StructType\NotifDetails $notifDetails
     * @return \StructType\OTA_NotifReportRQ
     */
    public function setNotifDetails(\StructType\NotifDetails $notifDetails = null)
    {
        $this->NotifDetails = $notifDetails;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\OTA_NotifReportRQ
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
