<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OntologyActivityType StructType
 * Meta information extracted from the WSDL
 * - documentation: Activity related information with ontology reference.
 * @subpackage Structs
 */
class OntologyActivityType extends AbstractStructBase
{
    /**
     * The Type
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Type
     */
    public $Type;
    /**
     * The OntologyExtension
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - ref: OntologyExtension
     * @var mixed
     */
    public $OntologyExtension;
    /**
     * Constructor method for OntologyActivityType
     * @uses OntologyActivityType::setType()
     * @uses OntologyActivityType::setOntologyExtension()
     * @param \StructType\Type $type
     * @param mixed $ontologyExtension
     */
    public function __construct(\StructType\Type $type = null, $ontologyExtension = null)
    {
        $this
            ->setType($type)
            ->setOntologyExtension($ontologyExtension);
    }
    /**
     * Get Type value
     * @return \StructType\Type|null
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @param \StructType\Type $type
     * @return \StructType\OntologyActivityType
     */
    public function setType(\StructType\Type $type = null)
    {
        $this->Type = $type;
        return $this;
    }
    /**
     * Get OntologyExtension value
     * @return mixed|null
     */
    public function getOntologyExtension()
    {
        return $this->OntologyExtension;
    }
    /**
     * Set OntologyExtension value
     * @param mixed $ontologyExtension
     * @return \StructType\OntologyActivityType
     */
    public function setOntologyExtension($ontologyExtension = null)
    {
        $this->OntologyExtension = $ontologyExtension;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\OntologyActivityType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
