<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PaymentSchedule StructType
 * Meta information extracted from the WSDL
 * - documentation: Specifies the payment schedule information.
 * @subpackage Structs
 */
class PaymentSchedule extends AbstractStructBase
{
    /**
     * The Payment
     * Meta information extracted from the WSDL
     * - maxOccurs: 99
     * @var \StructType\Payment[]
     */
    public $Payment;
    /**
     * Constructor method for PaymentSchedule
     * @uses PaymentSchedule::setPayment()
     * @param \StructType\Payment[] $payment
     */
    public function __construct(array $payment = array())
    {
        $this
            ->setPayment($payment);
    }
    /**
     * Get Payment value
     * @return \StructType\Payment[]|null
     */
    public function getPayment()
    {
        return $this->Payment;
    }
    /**
     * This method is responsible for validating the values passed to the setPayment method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPayment method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePaymentForArrayConstraintsFromSetPayment(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $paymentSchedulePaymentItem) {
            // validation for constraint: itemType
            if (!$paymentSchedulePaymentItem instanceof \StructType\Payment) {
                $invalidValues[] = is_object($paymentSchedulePaymentItem) ? get_class($paymentSchedulePaymentItem) : sprintf('%s(%s)', gettype($paymentSchedulePaymentItem), var_export($paymentSchedulePaymentItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Payment property can only contain items of type \StructType\Payment, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Payment value
     * @throws \InvalidArgumentException
     * @param \StructType\Payment[] $payment
     * @return \StructType\PaymentSchedule
     */
    public function setPayment(array $payment = array())
    {
        // validation for constraint: array
        if ('' !== ($paymentArrayErrorMessage = self::validatePaymentForArrayConstraintsFromSetPayment($payment))) {
            throw new \InvalidArgumentException($paymentArrayErrorMessage, __LINE__);
        }
        // validation for constraint: maxOccurs(99)
        if (is_array($payment) && count($payment) > 99) {
            throw new \InvalidArgumentException(sprintf('Invalid count of %s, the number of elements contained by the property must be less than or equal to 99', count($payment)), __LINE__);
        }
        $this->Payment = $payment;
        return $this;
    }
    /**
     * Add item to Payment value
     * @throws \InvalidArgumentException
     * @param \StructType\Payment $item
     * @return \StructType\PaymentSchedule
     */
    public function addToPayment(\StructType\Payment $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Payment) {
            throw new \InvalidArgumentException(sprintf('The Payment property can only contain items of type \StructType\Payment, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        // validation for constraint: maxOccurs(99)
        if (is_array($this->Payment) && count($this->Payment) >= 99) {
            throw new \InvalidArgumentException(sprintf('You can\'t add anymore element to this property that already contains %s elements, the number of elements contained by the property must be less than or equal to 99', count($this->Payment)), __LINE__);
        }
        $this->Payment[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PaymentSchedule
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
