<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PhonesType StructType
 * Meta information extracted from the WSDL
 * - documentation: Provides detailed phone information.
 * @subpackage Structs
 */
class PhonesType extends AbstractStructBase
{
    /**
     * The Phone
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\Phone[]
     */
    public $Phone;
    /**
     * Constructor method for PhonesType
     * @uses PhonesType::setPhone()
     * @param \StructType\Phone[] $phone
     */
    public function __construct(array $phone = array())
    {
        $this
            ->setPhone($phone);
    }
    /**
     * Get Phone value
     * @return \StructType\Phone[]|null
     */
    public function getPhone()
    {
        return $this->Phone;
    }
    /**
     * This method is responsible for validating the values passed to the setPhone method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPhone method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePhoneForArrayConstraintsFromSetPhone(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $phonesTypePhoneItem) {
            // validation for constraint: itemType
            if (!$phonesTypePhoneItem instanceof \StructType\Phone) {
                $invalidValues[] = is_object($phonesTypePhoneItem) ? get_class($phonesTypePhoneItem) : sprintf('%s(%s)', gettype($phonesTypePhoneItem), var_export($phonesTypePhoneItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Phone property can only contain items of type \StructType\Phone, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Phone value
     * @throws \InvalidArgumentException
     * @param \StructType\Phone[] $phone
     * @return \StructType\PhonesType
     */
    public function setPhone(array $phone = array())
    {
        // validation for constraint: array
        if ('' !== ($phoneArrayErrorMessage = self::validatePhoneForArrayConstraintsFromSetPhone($phone))) {
            throw new \InvalidArgumentException($phoneArrayErrorMessage, __LINE__);
        }
        $this->Phone = $phone;
        return $this;
    }
    /**
     * Add item to Phone value
     * @throws \InvalidArgumentException
     * @param \StructType\Phone $item
     * @return \StructType\PhonesType
     */
    public function addToPhone(\StructType\Phone $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Phone) {
            throw new \InvalidArgumentException(sprintf('The Phone property can only contain items of type \StructType\Phone, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Phone[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PhonesType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
