<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PlanCostType StructType
 * Meta information extracted from the WSDL
 * - documentation: Contains information about the total price of the insurance plan.
 * @subpackage Structs
 */
class PlanCostType extends AbstractStructBase
{
    /**
     * The BasePremium
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\BasePremium
     */
    public $BasePremium;
    /**
     * The Charges
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Charges
     */
    public $Charges;
    /**
     * Constructor method for PlanCostType
     * @uses PlanCostType::setBasePremium()
     * @uses PlanCostType::setCharges()
     * @param \StructType\BasePremium $basePremium
     * @param \StructType\Charges $charges
     */
    public function __construct(\StructType\BasePremium $basePremium = null, \StructType\Charges $charges = null)
    {
        $this
            ->setBasePremium($basePremium)
            ->setCharges($charges);
    }
    /**
     * Get BasePremium value
     * @return \StructType\BasePremium|null
     */
    public function getBasePremium()
    {
        return $this->BasePremium;
    }
    /**
     * Set BasePremium value
     * @param \StructType\BasePremium $basePremium
     * @return \StructType\PlanCostType
     */
    public function setBasePremium(\StructType\BasePremium $basePremium = null)
    {
        $this->BasePremium = $basePremium;
        return $this;
    }
    /**
     * Get Charges value
     * @return \StructType\Charges|null
     */
    public function getCharges()
    {
        return $this->Charges;
    }
    /**
     * Set Charges value
     * @param \StructType\Charges $charges
     * @return \StructType\PlanCostType
     */
    public function setCharges(\StructType\Charges $charges = null)
    {
        $this->Charges = $charges;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PlanCostType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
