<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PolicyInfoCodes StructType
 * Meta information extracted from the WSDL
 * - documentation: Detailed property policy information.
 * @subpackage Structs
 */
class PolicyInfoCodes extends AbstractStructBase
{
    /**
     * The PolicyInfoCode
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\PolicyInfoCode[]
     */
    public $PolicyInfoCode;
    /**
     * Constructor method for PolicyInfoCodes
     * @uses PolicyInfoCodes::setPolicyInfoCode()
     * @param \StructType\PolicyInfoCode[] $policyInfoCode
     */
    public function __construct(array $policyInfoCode = array())
    {
        $this
            ->setPolicyInfoCode($policyInfoCode);
    }
    /**
     * Get PolicyInfoCode value
     * @return \StructType\PolicyInfoCode[]|null
     */
    public function getPolicyInfoCode()
    {
        return $this->PolicyInfoCode;
    }
    /**
     * This method is responsible for validating the values passed to the setPolicyInfoCode method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPolicyInfoCode method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePolicyInfoCodeForArrayConstraintsFromSetPolicyInfoCode(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $policyInfoCodesPolicyInfoCodeItem) {
            // validation for constraint: itemType
            if (!$policyInfoCodesPolicyInfoCodeItem instanceof \StructType\PolicyInfoCode) {
                $invalidValues[] = is_object($policyInfoCodesPolicyInfoCodeItem) ? get_class($policyInfoCodesPolicyInfoCodeItem) : sprintf('%s(%s)', gettype($policyInfoCodesPolicyInfoCodeItem), var_export($policyInfoCodesPolicyInfoCodeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PolicyInfoCode property can only contain items of type \StructType\PolicyInfoCode, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PolicyInfoCode value
     * @throws \InvalidArgumentException
     * @param \StructType\PolicyInfoCode[] $policyInfoCode
     * @return \StructType\PolicyInfoCodes
     */
    public function setPolicyInfoCode(array $policyInfoCode = array())
    {
        // validation for constraint: array
        if ('' !== ($policyInfoCodeArrayErrorMessage = self::validatePolicyInfoCodeForArrayConstraintsFromSetPolicyInfoCode($policyInfoCode))) {
            throw new \InvalidArgumentException($policyInfoCodeArrayErrorMessage, __LINE__);
        }
        $this->PolicyInfoCode = $policyInfoCode;
        return $this;
    }
    /**
     * Add item to PolicyInfoCode value
     * @throws \InvalidArgumentException
     * @param \StructType\PolicyInfoCode $item
     * @return \StructType\PolicyInfoCodes
     */
    public function addToPolicyInfoCode(\StructType\PolicyInfoCode $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PolicyInfoCode) {
            throw new \InvalidArgumentException(sprintf('The PolicyInfoCode property can only contain items of type \StructType\PolicyInfoCode, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PolicyInfoCode[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PolicyInfoCodes
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
