<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PrerequisiteInventory StructType
 * Meta information extracted from the WSDL
 * - documentation: Defines inventory (e.g. room type, meal plan) which must be booked for this supplement to apply.
 * @subpackage Structs
 */
class PrerequisiteInventory extends AbstractStructBase
{
    /**
     * The InvCode
     * Meta information extracted from the WSDL
     * - documentation: A code defining an inventory item which must be booked for this supplement to apply.
     * - use: optional
     * @var string
     */
    public $InvCode;
    /**
     * The InvType
     * Meta information extracted from the WSDL
     * - documentation: The inventory type of the item identified by the code in InvCode.
     * - use: optional
     * @var string
     */
    public $InvType;
    /**
     * Constructor method for PrerequisiteInventory
     * @uses PrerequisiteInventory::setInvCode()
     * @uses PrerequisiteInventory::setInvType()
     * @param string $invCode
     * @param string $invType
     */
    public function __construct($invCode = null, $invType = null)
    {
        $this
            ->setInvCode($invCode)
            ->setInvType($invType);
    }
    /**
     * Get InvCode value
     * @return string|null
     */
    public function getInvCode()
    {
        return $this->InvCode;
    }
    /**
     * Set InvCode value
     * @param string $invCode
     * @return \StructType\PrerequisiteInventory
     */
    public function setInvCode($invCode = null)
    {
        // validation for constraint: string
        if (!is_null($invCode) && !is_string($invCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($invCode, true), gettype($invCode)), __LINE__);
        }
        $this->InvCode = $invCode;
        return $this;
    }
    /**
     * Get InvType value
     * @return string|null
     */
    public function getInvType()
    {
        return $this->InvType;
    }
    /**
     * Set InvType value
     * @param string $invType
     * @return \StructType\PrerequisiteInventory
     */
    public function setInvType($invType = null)
    {
        // validation for constraint: string
        if (!is_null($invType) && !is_string($invType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($invType, true), gettype($invType)), __LINE__);
        }
        $this->InvType = $invType;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PrerequisiteInventory
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
