<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RatePlanLevelFee StructType
 * Meta information extracted from the WSDL
 * - documentation: A Fee that is attached directly to the RatePlan. Can be used to send a global surcharge at the RatePlan level.
 * @subpackage Structs
 */
class RatePlanLevelFee extends AbstractStructBase
{
    /**
     * The Fee
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\Fee[]
     */
    public $Fee;
    /**
     * Constructor method for RatePlanLevelFee
     * @uses RatePlanLevelFee::setFee()
     * @param \StructType\Fee[] $fee
     */
    public function __construct(array $fee = array())
    {
        $this
            ->setFee($fee);
    }
    /**
     * Get Fee value
     * @return \StructType\Fee[]|null
     */
    public function getFee()
    {
        return $this->Fee;
    }
    /**
     * This method is responsible for validating the values passed to the setFee method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFee method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFeeForArrayConstraintsFromSetFee(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $ratePlanLevelFeeFeeItem) {
            // validation for constraint: itemType
            if (!$ratePlanLevelFeeFeeItem instanceof \StructType\Fee) {
                $invalidValues[] = is_object($ratePlanLevelFeeFeeItem) ? get_class($ratePlanLevelFeeFeeItem) : sprintf('%s(%s)', gettype($ratePlanLevelFeeFeeItem), var_export($ratePlanLevelFeeFeeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Fee property can only contain items of type \StructType\Fee, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Fee value
     * @throws \InvalidArgumentException
     * @param \StructType\Fee[] $fee
     * @return \StructType\RatePlanLevelFee
     */
    public function setFee(array $fee = array())
    {
        // validation for constraint: array
        if ('' !== ($feeArrayErrorMessage = self::validateFeeForArrayConstraintsFromSetFee($fee))) {
            throw new \InvalidArgumentException($feeArrayErrorMessage, __LINE__);
        }
        $this->Fee = $fee;
        return $this;
    }
    /**
     * Add item to Fee value
     * @throws \InvalidArgumentException
     * @param \StructType\Fee $item
     * @return \StructType\RatePlanLevelFee
     */
    public function addToFee(\StructType\Fee $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Fee) {
            throw new \InvalidArgumentException(sprintf('The Fee property can only contain items of type \StructType\Fee, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Fee[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RatePlanLevelFee
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
