<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RatePlanShoulders StructType
 * Meta information extracted from the WSDL
 * - documentation: A collection of RatePlanShoulders.
 * @subpackage Structs
 */
class RatePlanShoulders extends AbstractStructBase
{
    /**
     * The RatePlanShoulder
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\RatePlanShoulder[]
     */
    public $RatePlanShoulder;
    /**
     * Constructor method for RatePlanShoulders
     * @uses RatePlanShoulders::setRatePlanShoulder()
     * @param \StructType\RatePlanShoulder[] $ratePlanShoulder
     */
    public function __construct(array $ratePlanShoulder = array())
    {
        $this
            ->setRatePlanShoulder($ratePlanShoulder);
    }
    /**
     * Get RatePlanShoulder value
     * @return \StructType\RatePlanShoulder[]|null
     */
    public function getRatePlanShoulder()
    {
        return $this->RatePlanShoulder;
    }
    /**
     * This method is responsible for validating the values passed to the setRatePlanShoulder method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRatePlanShoulder method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRatePlanShoulderForArrayConstraintsFromSetRatePlanShoulder(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $ratePlanShouldersRatePlanShoulderItem) {
            // validation for constraint: itemType
            if (!$ratePlanShouldersRatePlanShoulderItem instanceof \StructType\RatePlanShoulder) {
                $invalidValues[] = is_object($ratePlanShouldersRatePlanShoulderItem) ? get_class($ratePlanShouldersRatePlanShoulderItem) : sprintf('%s(%s)', gettype($ratePlanShouldersRatePlanShoulderItem), var_export($ratePlanShouldersRatePlanShoulderItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RatePlanShoulder property can only contain items of type \StructType\RatePlanShoulder, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RatePlanShoulder value
     * @throws \InvalidArgumentException
     * @param \StructType\RatePlanShoulder[] $ratePlanShoulder
     * @return \StructType\RatePlanShoulders
     */
    public function setRatePlanShoulder(array $ratePlanShoulder = array())
    {
        // validation for constraint: array
        if ('' !== ($ratePlanShoulderArrayErrorMessage = self::validateRatePlanShoulderForArrayConstraintsFromSetRatePlanShoulder($ratePlanShoulder))) {
            throw new \InvalidArgumentException($ratePlanShoulderArrayErrorMessage, __LINE__);
        }
        $this->RatePlanShoulder = $ratePlanShoulder;
        return $this;
    }
    /**
     * Add item to RatePlanShoulder value
     * @throws \InvalidArgumentException
     * @param \StructType\RatePlanShoulder $item
     * @return \StructType\RatePlanShoulders
     */
    public function addToRatePlanShoulder(\StructType\RatePlanShoulder $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RatePlanShoulder) {
            throw new \InvalidArgumentException(sprintf('The RatePlanShoulder property can only contain items of type \StructType\RatePlanShoulder, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RatePlanShoulder[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RatePlanShoulders
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
