<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RefPointsType StructType
 * Meta information extracted from the WSDL
 * - documentation: Reference points in relation to/from the current entity.
 * @subpackage Structs
 */
class RefPointsType extends AbstractStructBase
{
    /**
     * The RefPoint
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\RefPoint[]
     */
    public $RefPoint;
    /**
     * Constructor method for RefPointsType
     * @uses RefPointsType::setRefPoint()
     * @param \StructType\RefPoint[] $refPoint
     */
    public function __construct(array $refPoint = array())
    {
        $this
            ->setRefPoint($refPoint);
    }
    /**
     * Get RefPoint value
     * @return \StructType\RefPoint[]|null
     */
    public function getRefPoint()
    {
        return $this->RefPoint;
    }
    /**
     * This method is responsible for validating the values passed to the setRefPoint method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRefPoint method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRefPointForArrayConstraintsFromSetRefPoint(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $refPointsTypeRefPointItem) {
            // validation for constraint: itemType
            if (!$refPointsTypeRefPointItem instanceof \StructType\RefPoint) {
                $invalidValues[] = is_object($refPointsTypeRefPointItem) ? get_class($refPointsTypeRefPointItem) : sprintf('%s(%s)', gettype($refPointsTypeRefPointItem), var_export($refPointsTypeRefPointItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RefPoint property can only contain items of type \StructType\RefPoint, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RefPoint value
     * @throws \InvalidArgumentException
     * @param \StructType\RefPoint[] $refPoint
     * @return \StructType\RefPointsType
     */
    public function setRefPoint(array $refPoint = array())
    {
        // validation for constraint: array
        if ('' !== ($refPointArrayErrorMessage = self::validateRefPointForArrayConstraintsFromSetRefPoint($refPoint))) {
            throw new \InvalidArgumentException($refPointArrayErrorMessage, __LINE__);
        }
        $this->RefPoint = $refPoint;
        return $this;
    }
    /**
     * Add item to RefPoint value
     * @throws \InvalidArgumentException
     * @param \StructType\RefPoint $item
     * @return \StructType\RefPointsType
     */
    public function addToRefPoint(\StructType\RefPoint $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RefPoint) {
            throw new \InvalidArgumentException(sprintf('The RefPoint property can only contain items of type \StructType\RefPoint, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RefPoint[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RefPointsType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
