<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SrvcInfoCodes StructType
 * Meta information extracted from the WSDL
 * - documentation: Collection of type of restaurant offered.
 * @subpackage Structs
 */
class SrvcInfoCodes extends AbstractStructBase
{
    /**
     * The SrvcInfoCode
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\SrvcInfoCode[]
     */
    public $SrvcInfoCode;
    /**
     * Constructor method for SrvcInfoCodes
     * @uses SrvcInfoCodes::setSrvcInfoCode()
     * @param \StructType\SrvcInfoCode[] $srvcInfoCode
     */
    public function __construct(array $srvcInfoCode = array())
    {
        $this
            ->setSrvcInfoCode($srvcInfoCode);
    }
    /**
     * Get SrvcInfoCode value
     * @return \StructType\SrvcInfoCode[]|null
     */
    public function getSrvcInfoCode()
    {
        return $this->SrvcInfoCode;
    }
    /**
     * This method is responsible for validating the values passed to the setSrvcInfoCode method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSrvcInfoCode method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSrvcInfoCodeForArrayConstraintsFromSetSrvcInfoCode(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $srvcInfoCodesSrvcInfoCodeItem) {
            // validation for constraint: itemType
            if (!$srvcInfoCodesSrvcInfoCodeItem instanceof \StructType\SrvcInfoCode) {
                $invalidValues[] = is_object($srvcInfoCodesSrvcInfoCodeItem) ? get_class($srvcInfoCodesSrvcInfoCodeItem) : sprintf('%s(%s)', gettype($srvcInfoCodesSrvcInfoCodeItem), var_export($srvcInfoCodesSrvcInfoCodeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SrvcInfoCode property can only contain items of type \StructType\SrvcInfoCode, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SrvcInfoCode value
     * @throws \InvalidArgumentException
     * @param \StructType\SrvcInfoCode[] $srvcInfoCode
     * @return \StructType\SrvcInfoCodes
     */
    public function setSrvcInfoCode(array $srvcInfoCode = array())
    {
        // validation for constraint: array
        if ('' !== ($srvcInfoCodeArrayErrorMessage = self::validateSrvcInfoCodeForArrayConstraintsFromSetSrvcInfoCode($srvcInfoCode))) {
            throw new \InvalidArgumentException($srvcInfoCodeArrayErrorMessage, __LINE__);
        }
        $this->SrvcInfoCode = $srvcInfoCode;
        return $this;
    }
    /**
     * Add item to SrvcInfoCode value
     * @throws \InvalidArgumentException
     * @param \StructType\SrvcInfoCode $item
     * @return \StructType\SrvcInfoCodes
     */
    public function addToSrvcInfoCode(\StructType\SrvcInfoCode $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SrvcInfoCode) {
            throw new \InvalidArgumentException(sprintf('The SrvcInfoCode property can only contain items of type \StructType\SrvcInfoCode, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SrvcInfoCode[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SrvcInfoCodes
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
