<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for StatisticApplicationSets StructType
 * Meta information extracted from the WSDL
 * - documentation: Collection of StatisticApplicationSet Elements.
 * @subpackage Structs
 */
class StatisticApplicationSets extends AbstractStructBase
{
    /**
     * The StatisticApplicationSet
     * Meta information extracted from the WSDL
     * - documentation: Repeated for each date or set of statistic codes.
     * - maxOccurs: unbounded
     * @var mixed[]
     */
    public $StatisticApplicationSet;
    /**
     * Constructor method for StatisticApplicationSets
     * @uses StatisticApplicationSets::setStatisticApplicationSet()
     * @param mixed[] $statisticApplicationSet
     */
    public function __construct(array $statisticApplicationSet = array())
    {
        $this
            ->setStatisticApplicationSet($statisticApplicationSet);
    }
    /**
     * Get StatisticApplicationSet value
     * @return mixed[]|null
     */
    public function getStatisticApplicationSet()
    {
        return $this->StatisticApplicationSet;
    }
    /**
     * This method is responsible for validating the values passed to the setStatisticApplicationSet method
     * This method is willingly generated in order to preserve the one-line inline validation within the setStatisticApplicationSet method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateStatisticApplicationSetForArrayConstraintsFromSetStatisticApplicationSet(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $statisticApplicationSetsStatisticApplicationSetItem) {
            // validation for constraint: itemType
            if (false) {
                $invalidValues[] = is_object($statisticApplicationSetsStatisticApplicationSetItem) ? get_class($statisticApplicationSetsStatisticApplicationSetItem) : sprintf('%s(%s)', gettype($statisticApplicationSetsStatisticApplicationSetItem), var_export($statisticApplicationSetsStatisticApplicationSetItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The StatisticApplicationSet property can only contain items of type anyType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set StatisticApplicationSet value
     * @throws \InvalidArgumentException
     * @param mixed[] $statisticApplicationSet
     * @return \StructType\StatisticApplicationSets
     */
    public function setStatisticApplicationSet(array $statisticApplicationSet = array())
    {
        // validation for constraint: array
        if ('' !== ($statisticApplicationSetArrayErrorMessage = self::validateStatisticApplicationSetForArrayConstraintsFromSetStatisticApplicationSet($statisticApplicationSet))) {
            throw new \InvalidArgumentException($statisticApplicationSetArrayErrorMessage, __LINE__);
        }
        $this->StatisticApplicationSet = $statisticApplicationSet;
        return $this;
    }
    /**
     * Add item to StatisticApplicationSet value
     * @throws \InvalidArgumentException
     * @param mixed $item
     * @return \StructType\StatisticApplicationSets
     */
    public function addToStatisticApplicationSet($item)
    {
        // validation for constraint: itemType
        if (false) {
            throw new \InvalidArgumentException(sprintf('The StatisticApplicationSet property can only contain items of type anyType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->StatisticApplicationSet[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\StatisticApplicationSets
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
