<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for StayRequirements StructType
 * Meta information extracted from the WSDL
 * - documentation: Collection of stay requirements.
 * @subpackage Structs
 */
class StayRequirements extends AbstractStructBase
{
    /**
     * The StayRequirement
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\StayRequirement[]
     */
    public $StayRequirement;
    /**
     * Constructor method for StayRequirements
     * @uses StayRequirements::setStayRequirement()
     * @param \StructType\StayRequirement[] $stayRequirement
     */
    public function __construct(array $stayRequirement = array())
    {
        $this
            ->setStayRequirement($stayRequirement);
    }
    /**
     * Get StayRequirement value
     * @return \StructType\StayRequirement[]|null
     */
    public function getStayRequirement()
    {
        return $this->StayRequirement;
    }
    /**
     * This method is responsible for validating the values passed to the setStayRequirement method
     * This method is willingly generated in order to preserve the one-line inline validation within the setStayRequirement method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateStayRequirementForArrayConstraintsFromSetStayRequirement(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $stayRequirementsStayRequirementItem) {
            // validation for constraint: itemType
            if (!$stayRequirementsStayRequirementItem instanceof \StructType\StayRequirement) {
                $invalidValues[] = is_object($stayRequirementsStayRequirementItem) ? get_class($stayRequirementsStayRequirementItem) : sprintf('%s(%s)', gettype($stayRequirementsStayRequirementItem), var_export($stayRequirementsStayRequirementItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The StayRequirement property can only contain items of type \StructType\StayRequirement, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set StayRequirement value
     * @throws \InvalidArgumentException
     * @param \StructType\StayRequirement[] $stayRequirement
     * @return \StructType\StayRequirements
     */
    public function setStayRequirement(array $stayRequirement = array())
    {
        // validation for constraint: array
        if ('' !== ($stayRequirementArrayErrorMessage = self::validateStayRequirementForArrayConstraintsFromSetStayRequirement($stayRequirement))) {
            throw new \InvalidArgumentException($stayRequirementArrayErrorMessage, __LINE__);
        }
        $this->StayRequirement = $stayRequirement;
        return $this;
    }
    /**
     * Add item to StayRequirement value
     * @throws \InvalidArgumentException
     * @param \StructType\StayRequirement $item
     * @return \StructType\StayRequirements
     */
    public function addToStayRequirement(\StructType\StayRequirement $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\StayRequirement) {
            throw new \InvalidArgumentException(sprintf('The StayRequirement property can only contain items of type \StructType\StayRequirement, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->StayRequirement[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\StayRequirements
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
