<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ThreeDomainSecurity StructType
 * Meta information extracted from the WSDL
 * - documentation: Note: This contains 3-D Secure protocol information for online credit and debit card transactions for programs such as Verified by Visa, MasterCard SecureCode, J/Secure and SafeKey. | 3-D secure financial authorization information.
 * @subpackage Structs
 */
class ThreeDomainSecurity extends AbstractStructBase
{
    /**
     * The Gateway
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Gateway
     */
    public $Gateway;
    /**
     * The Results
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Results
     */
    public $Results;
    /**
     * Constructor method for ThreeDomainSecurity
     * @uses ThreeDomainSecurity::setGateway()
     * @uses ThreeDomainSecurity::setResults()
     * @param \StructType\Gateway $gateway
     * @param \StructType\Results $results
     */
    public function __construct(\StructType\Gateway $gateway = null, \StructType\Results $results = null)
    {
        $this
            ->setGateway($gateway)
            ->setResults($results);
    }
    /**
     * Get Gateway value
     * @return \StructType\Gateway|null
     */
    public function getGateway()
    {
        return $this->Gateway;
    }
    /**
     * Set Gateway value
     * @param \StructType\Gateway $gateway
     * @return \StructType\ThreeDomainSecurity
     */
    public function setGateway(\StructType\Gateway $gateway = null)
    {
        $this->Gateway = $gateway;
        return $this;
    }
    /**
     * Get Results value
     * @return \StructType\Results|null
     */
    public function getResults()
    {
        return $this->Results;
    }
    /**
     * Set Results value
     * @param \StructType\Results $results
     * @return \StructType\ThreeDomainSecurity
     */
    public function setResults(\StructType\Results $results = null)
    {
        $this->Results = $results;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ThreeDomainSecurity
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
