<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TotalAmount StructType
 * Meta information extracted from the WSDL
 * - documentation: The total residual value, including applicable tax, fees and charges.
 * @subpackage Structs
 */
class TotalAmount extends AbstractStructBase
{
    /**
     * The Purpose
     * Meta information extracted from the WSDL
     * - documentation: Not applicable here.
     * - use: optional
     * @var string
     */
    public $Purpose;
    /**
     * Constructor method for TotalAmount
     * @uses TotalAmount::setPurpose()
     * @param string $purpose
     */
    public function __construct($purpose = null)
    {
        $this
            ->setPurpose($purpose);
    }
    /**
     * Get Purpose value
     * @return string|null
     */
    public function getPurpose()
    {
        return $this->Purpose;
    }
    /**
     * Set Purpose value
     * @uses \EnumType\PurposeType::valueIsValid()
     * @uses \EnumType\PurposeType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $purpose
     * @return \StructType\TotalAmount
     */
    public function setPurpose($purpose = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\PurposeType::valueIsValid($purpose)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\PurposeType', is_array($purpose) ? implode(', ', $purpose) : var_export($purpose, true), implode(', ', \EnumType\PurposeType::getValidValues())), __LINE__);
        }
        $this->Purpose = $purpose;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TotalAmount
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
