<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TransactionPassword StructType
 * Meta information extracted from the WSDL
 * - documentation: Merchant transaction password information.
 * @subpackage Structs
 */
class TransactionPassword extends AbstractStructBase
{
    /**
     * The Secure
     * Meta information extracted from the WSDL
     * - documentation: Example: xxxxxxxxxxxx4444 (masked) | Example: 5dfc52b51bd35553df8592078de921bc (encrypted) | Example: AEGHV234AUD54367 (tokenized) | Secure representation.
     * - choice: Secure | PlainText
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - minOccurs: 0
     * @var mixed
     */
    public $Secure;
    /**
     * The PlainText
     * Meta information extracted from the WSDL
     * - documentation: Example: acG@26!w | Plain text representation.
     * - choice: Secure | PlainText
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - minOccurs: 0
     * @var mixed
     */
    public $PlainText;
    /**
     * Constructor method for TransactionPassword
     * @uses TransactionPassword::setSecure()
     * @uses TransactionPassword::setPlainText()
     * @param mixed $secure
     * @param mixed $plainText
     */
    public function __construct($secure = null, $plainText = null)
    {
        $this
            ->setSecure($secure)
            ->setPlainText($plainText);
    }
    /**
     * Get Secure value
     * @return mixed|null
     */
    public function getSecure()
    {
        return isset($this->Secure) ? $this->Secure : null;
    }
    /**
     * This method is responsible for validating the value passed to the setSecure method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSecure method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateSecureForChoiceConstraintsFromSetSecure($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'PlainText',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property Secure can\'t be set as the property %s is already set. Only one property must be set among these properties: Secure, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set Secure value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param mixed $secure
     * @return \StructType\TransactionPassword
     */
    public function setSecure($secure = null)
    {
        // validation for constraint: choice(Secure, PlainText)
        if ('' !== ($secureChoiceErrorMessage = self::validateSecureForChoiceConstraintsFromSetSecure($secure))) {
            throw new \InvalidArgumentException($secureChoiceErrorMessage, __LINE__);
        }
        if (is_null($secure) || (is_array($secure) && empty($secure))) {
            unset($this->Secure);
        } else {
            $this->Secure = $secure;
        }
        return $this;
    }
    /**
     * Get PlainText value
     * @return mixed|null
     */
    public function getPlainText()
    {
        return isset($this->PlainText) ? $this->PlainText : null;
    }
    /**
     * This method is responsible for validating the value passed to the setPlainText method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPlainText method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validatePlainTextForChoiceConstraintsFromSetPlainText($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'Secure',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property PlainText can\'t be set as the property %s is already set. Only one property must be set among these properties: PlainText, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set PlainText value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param mixed $plainText
     * @return \StructType\TransactionPassword
     */
    public function setPlainText($plainText = null)
    {
        // validation for constraint: choice(Secure, PlainText)
        if ('' !== ($plainTextChoiceErrorMessage = self::validatePlainTextForChoiceConstraintsFromSetPlainText($plainText))) {
            throw new \InvalidArgumentException($plainTextChoiceErrorMessage, __LINE__);
        }
        if (is_null($plainText) || (is_array($plainText) && empty($plainText))) {
            unset($this->PlainText);
        } else {
            $this->PlainText = $plainText;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TransactionPassword
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
