<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VehNotifReport StructType
 * Meta information extracted from the WSDL
 * - documentation: Used to provide business details regarding processing of a previous vehicle message.
 * @subpackage Structs
 */
class VehNotifReport extends AbstractStructBase
{
    /**
     * The VehRes
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\VehRes
     */
    public $VehRes;
    /**
     * Constructor method for VehNotifReport
     * @uses VehNotifReport::setVehRes()
     * @param \StructType\VehRes $vehRes
     */
    public function __construct(\StructType\VehRes $vehRes = null)
    {
        $this
            ->setVehRes($vehRes);
    }
    /**
     * Get VehRes value
     * @return \StructType\VehRes|null
     */
    public function getVehRes()
    {
        return $this->VehRes;
    }
    /**
     * Set VehRes value
     * @param \StructType\VehRes $vehRes
     * @return \StructType\VehNotifReport
     */
    public function setVehRes(\StructType\VehRes $vehRes = null)
    {
        $this->VehRes = $vehRes;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\VehNotifReport
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
