<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VehRes StructType
 * Meta information extracted from the WSDL
 * - documentation: Vehicle reservation.
 * @subpackage Structs
 */
class VehRes extends AbstractStructBase
{
    /**
     * The VehNotifReportRQCore
     * @var \StructType\VehNotifReportRQCore
     */
    public $VehNotifReportRQCore;
    /**
     * The VehNotifReportRQInfo
     * Meta information extracted from the WSDL
     * - documentation: Identifies the supplemental information associated with the request providing information on the reservation of a rental vehicle.
     * - minOccurs: 0
     * @var \StructType\VehicleResRSAdditionalInfoType
     */
    public $VehNotifReportRQInfo;
    /**
     * Constructor method for VehRes
     * @uses VehRes::setVehNotifReportRQCore()
     * @uses VehRes::setVehNotifReportRQInfo()
     * @param \StructType\VehNotifReportRQCore $vehNotifReportRQCore
     * @param \StructType\VehicleResRSAdditionalInfoType $vehNotifReportRQInfo
     */
    public function __construct(\StructType\VehNotifReportRQCore $vehNotifReportRQCore = null, \StructType\VehicleResRSAdditionalInfoType $vehNotifReportRQInfo = null)
    {
        $this
            ->setVehNotifReportRQCore($vehNotifReportRQCore)
            ->setVehNotifReportRQInfo($vehNotifReportRQInfo);
    }
    /**
     * Get VehNotifReportRQCore value
     * @return \StructType\VehNotifReportRQCore|null
     */
    public function getVehNotifReportRQCore()
    {
        return $this->VehNotifReportRQCore;
    }
    /**
     * Set VehNotifReportRQCore value
     * @param \StructType\VehNotifReportRQCore $vehNotifReportRQCore
     * @return \StructType\VehRes
     */
    public function setVehNotifReportRQCore(\StructType\VehNotifReportRQCore $vehNotifReportRQCore = null)
    {
        $this->VehNotifReportRQCore = $vehNotifReportRQCore;
        return $this;
    }
    /**
     * Get VehNotifReportRQInfo value
     * @return \StructType\VehicleResRSAdditionalInfoType|null
     */
    public function getVehNotifReportRQInfo()
    {
        return $this->VehNotifReportRQInfo;
    }
    /**
     * Set VehNotifReportRQInfo value
     * @param \StructType\VehicleResRSAdditionalInfoType $vehNotifReportRQInfo
     * @return \StructType\VehRes
     */
    public function setVehNotifReportRQInfo(\StructType\VehicleResRSAdditionalInfoType $vehNotifReportRQInfo = null)
    {
        $this->VehNotifReportRQInfo = $vehNotifReportRQInfo;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\VehRes
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
