<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VehicleReadRequest StructType
 * Meta information extracted from the WSDL
 * - documentation: To request a vehicle reservation when the confirmation number is not known.
 * @subpackage Structs
 */
class VehicleReadRequest extends VehicleRetrieveResRQCoreType
{
    /**
     * The VehRetResRQInfo
     * Meta information extracted from the WSDL
     * - documentation: Identifies the core and supplemental information associated with the request for the retrieval of a rental vehicle reservation.
     * @var \StructType\VehicleRetrieveResRQAdditionalInfoType
     */
    public $VehRetResRQInfo;
    /**
     * Constructor method for VehicleReadRequest
     * @uses VehicleReadRequest::setVehRetResRQInfo()
     * @param \StructType\VehicleRetrieveResRQAdditionalInfoType $vehRetResRQInfo
     */
    public function __construct(\StructType\VehicleRetrieveResRQAdditionalInfoType $vehRetResRQInfo = null)
    {
        $this
            ->setVehRetResRQInfo($vehRetResRQInfo);
    }
    /**
     * Get VehRetResRQInfo value
     * @return \StructType\VehicleRetrieveResRQAdditionalInfoType|null
     */
    public function getVehRetResRQInfo()
    {
        return $this->VehRetResRQInfo;
    }
    /**
     * Set VehRetResRQInfo value
     * @param \StructType\VehicleRetrieveResRQAdditionalInfoType $vehRetResRQInfo
     * @return \StructType\VehicleReadRequest
     */
    public function setVehRetResRQInfo(\StructType\VehicleRetrieveResRQAdditionalInfoType $vehRetResRQInfo = null)
    {
        $this->VehRetResRQInfo = $vehRetResRQInfo;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\VehicleReadRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
