<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VoluntaryRefunds StructType
 * Meta information extracted from the WSDL
 * - documentation: Specifies a Voluntary Refund (cancellation) charge.
 * @subpackage Structs
 */
class VoluntaryRefunds extends VoluntaryChangesType
{
    /**
     * The Description
     * Meta information extracted from the WSDL
     * - documentation: A description of the penalty.
     * - use: optional
     * @var string
     */
    public $Description;
    /**
     * Constructor method for VoluntaryRefunds
     * @uses VoluntaryRefunds::setDescription()
     * @param string $description
     */
    public function __construct($description = null)
    {
        $this
            ->setDescription($description);
    }
    /**
     * Get Description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->Description;
    }
    /**
     * Set Description value
     * @param string $description
     * @return \StructType\VoluntaryRefunds
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($description, true), gettype($description)), __LINE__);
        }
        $this->Description = $description;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\VoluntaryRefunds
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
